=== debian/changelog ===
insighttoolkit (3.20.0-13ubuntu1) oneiric; urgency=low

  * Set CMAKE_BUILD_TYPE to RelWithDebInfo for non ix86 targets to build
    with -O2, not -O3.
  * Build using binutils-gold on ARM, work-around LP: #641126.
  * Install into dist-packages, not site-packages.
  * Build using dh_python2.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 07 Sep 2011 14:32:21 +2000

insighttoolkit (3.20.0-13) unstable; urgency=low

  * Remove absolute paths to required libraries from
    /usr/lib/InsightToolkit/ITKLibraryDepends.cmake after building,
    closes: #635300.  Due to the multiarch transition, the original
    behavior frequently causes reverse build-deps to FTBFS.  This change
    should probably be reverted once all required libraries are
    multiarched.

 -- Michael Schutte <michi@debian.org>  Tue, 16 Aug 2011 20:52:58 +0200

insighttoolkit (3.20.0-12) unstable; urgency=low

  * patches/itkImageToImageFilterC.patch: Remove.
  * patches/wrap-iifilter-split.patch: New; replaces above patch.  Split
    itkImageToImageFilterB into 3 files, introducing FilterC and FilterD.

 -- Steve M. Robbins <smr@debian.org>  Fri, 12 Aug 2011 20:08:27 -0500

insighttoolkit (3.20.0-11) unstable; urgency=low

  * control: Build-depend on newer gccxml that removes "inline namespace"
    from c++config.h.  Closes: #632582.

 -- Steve M. Robbins <smr@debian.org>  Sun, 24 Jul 2011 00:16:22 -0500

insighttoolkit (3.20.0-10) unstable; urgency=low

  * patches/ptrdiff.patch.  New.  Include <stddef.h> to ensure ptrdiff_t
    is defined.  Closes: #625077, #624941, #625090.
  
  * rules: Enable optimized registration methods and transform IO
    factories.  Closes: #614519.
  
  * patches/tcl-install.patch: Set WRAP_ITK_PACKAGE_DIR to /usr/lib.
    Closes: #618736.
  
  * control: Build-depend on newer gccxml.

 -- Steve M. Robbins <smr@debian.org>  Fri, 06 May 2011 01:31:04 -0500

insighttoolkit (3.20.0-9) unstable; urgency=low

  * control: Build-depend on newer gccxml and cableswig.

 -- Steve M. Robbins <smr@debian.org>  Sun, 06 Mar 2011 15:11:09 -0600

insighttoolkit (3.20.0-8) unstable; urgency=low

  * rules: Remove parallel build.

 -- Steve M. Robbins <smr@debian.org>  Wed, 16 Feb 2011 00:44:55 -0600

insighttoolkit (3.20.0-7) unstable; urgency=low

  * patches/itkImageToImageFilterC.patch: New.  Split the
    ImageToImageFilter into smaller modules to avoid compiler table
    overflow (build failure).
  
  * rules: Try parallel build again.
  
 -- Steve M. Robbins <smr@debian.org>  Sat, 12 Feb 2011 20:04:44 -0600

insighttoolkit (3.20.0-6) unstable; urgency=low

  [Paul Novotny]
  * control:
  * rules:
  * patches/wrapitk-externalprojects.patch: New.  Add two External
    Projects to the WrapITK build. PyBuffer provides easy interoperability
    with numpy. ItkVtkGlue makes it easy to convert from and to VTK.
  
  * rules: Turn off wrapping 4D images, fix wrap setting misspellings.
  
  * patches/add-registration-optimizers.patch: New.  Add a couple new
    registration optimizers, including LBFGSBOptimizer used for B-spline
    3D registration.  Add a few array types to use the optimizers
    correctly.
  
  [Steve Robbins]
  * control: Add build-deps on libvtk5-dev, python-vtk for ItkVtkGlue.
    Remove unnecessary build-deps libjpeg62-dev, libtiff4-dev,
    libfreetype6-dev, libopenjpeg-dev, graphviz, libxext-dev, libxss-dev,
    libxft-dev, libpoppler-dev, libssl-dev.  Closes: #608394.

 -- Steve M. Robbins <smr@debian.org>  Mon, 07 Feb 2011 01:35:06 -0600

insighttoolkit (3.20.0-5) experimental; urgency=low

  * patches/wrapitk.patch: New.  Use ITK_LIBRARY_PROPERTIES to properly
    version libSwigRuntime{Python,Java,Tcl} and the Tcl shared libs (which
    are installed in /usr/lib).

  * rules: Install libSwigJava into /usr/lib.

 -- Steve M. Robbins <smr@debian.org>  Wed, 22 Dec 2010 23:32:20 -0600

insighttoolkit (3.20.0-4) experimental; urgency=low

  * rules: Really remove parallel build (don't set DEB_BUILD_PARALLEL).
  
  * insighttoolkit_3.20.0.orig-review.tar.bz2: New.  Contains contents of
    upstream "Code/Review" directory, heretofore removed from the .orig
    tarball.
  * rules: Build using Review and Review/Statistics.
  
  * rules: Switch from CSWIG wrapping to WrapITK wrapping for java,
    python, and tcl.

 -- Steve M. Robbins <smr@debian.org>  Sun, 19 Dec 2010 22:47:03 -0600

insighttoolkit (3.20.0-3) experimental; urgency=low

  * rules: Remove parallel build; still broken with cswig wrapping.  See
    https://buildd.debian.org/fetch.cgi?pkg=insighttoolkit;ver=3.20.0-1;arch=i386;stamp=1288336939
  
  * control: Bump Standards-Version to 3.9.1.

 -- Steve M. Robbins <smr@debian.org>  Sat, 30 Oct 2010 22:34:32 -0500

insighttoolkit (3.20.0-2) experimental; urgency=low

  * Switch to source package 3.0 (quilt) format.

  * rules: Embed SOVERSION in valgrind suppression files to avoid file
    conflicts on upgrade to new versions of insighttoolkit.  Closes:
    #600867.  Merge from branches/3.18.0
  
  * patches/metaio-test-vtk_source.patch: New.  Upstream fix for build
    error (thanks, Mathieu Malaterre).  Closes: #600677.

 -- Steve M. Robbins <smr@debian.org>  Sat, 30 Oct 2010 16:55:30 -0500

insighttoolkit (3.20.0-1) experimental; urgency=low

  * New upstream.
    - patches/itkTkImageViewer2D.patch: Remove.  Applied upstream.
    - patches/nifti-memleak.patch: Remove.  Applied upstream.

  * control.in: Adjust gccxml version dependency to match what used to be
    in control.

  * rules: Set version variables to 3.20.
  * control: Re-generate for libinsighttoolkit3.20.

  * patches/gccxml-workaround.patch: Remove.  Workaround no longer
    required as gccxml was fixed as of 2008-06-02.

  * rules: Use "make install/fast" to avoid a rebuild at install time.
    Closes: #587184.

  * rules: Enable parallel building (fixed upstream in May).  Closes:
    #578313.

 -- Steve M. Robbins <smr@debian.org>  Wed, 18 Aug 2010 22:03:06 -0500

insighttoolkit (3.18.0-4) unstable; urgency=low


